Subject: bug#60845: 30.0.50; [PATCH] Add tests for Eshell interactive completion (and fix a bug in it)

From: Jim Porter <[email-masked]>
Date: Mon, 30 Jan 2023 18:00:33 -0800

On 1/30/2023 6:54 AM, Stefan Monnier via Bug reports for GNU Emacs, the 
Swiss army knife of text editors wrote:
> It sounds good to me, but I'm definitely not well versed in this aspect
> of the interaction between Eshell and Pcomplete (more specifically,
> this is a part of their interaction which I find quite tricky), so it's
> good that you add corresponding regression tests.

Thanks for taking a look. I've merged my patches as e7d0aa248e. We can 
leave this open though to discuss what to do about the Pcomplete side of 
things. I think we can remove the workaround for Emacs 29, but maybe we 
want some additional changes.

(It would also be nice to add some more Pcomplete support on the Eshell 
side. For example, when completing arguments to 'echo', Pcomplete shows 
options for the real /bin/echo, instead of showing options for the 
built-in function 'eshell/echo'.)